Attribute VB_Name = "Mca32cmx"
Public Const COMM_INTERFACE_ETHERNET                As Integer = 0
Public Const COMM_INTERFACE_COM1                    As Integer = 1
Public Const COMM_INTERFACE_COM256                  As Integer = 256
Public Const COMM_INTERFACE_USB                     As Integer = 257
Public Const COMM_INTERFACE_USB_CHARGER             As Integer = 258
Public Const COMM_INTERFACE_COM1_RS485              As Integer = 259
Public Const COMM_INTERFACE_COM256_RS485            As Integer = 514
Public Const COMM_INTERFACE_USB_RS485               As Integer = 515

Public Const ERROR_OK                               As Integer = 0
Public Const ERROR_INTERFACE                        As Integer = 1
Public Const ERROR_INVALID_COMMAND                  As Integer = 2
Public Const ERROR_COMMUNICATION                    As Integer = 3
Public Const ERROR_INVALID_PARAM                    As Integer = 4
Public Const ERROR_RUNNING_MEAS                     As Integer = 5
Public Const ERROR_VIOLATED_RIGHT                   As Integer = 6
Public Const ERROR_STOPPED_MEAS                     As Integer = 7
Public Const ERROR_WRONG_MODE                       As Integer = 8
Public Const ERROR_UNHANDLED_COMMAND                As Integer = 9
Public Const ERROR_FILE_WRITING_IN_PROCCESS         As Integer = 10

Public Const GMODE_MCA                              As Integer = 0
Public Const GMODE_TRANSFER_ADC_VALUES              As Integer = 1
Public Const GMODE_OSCILLOSCOPE                     As Integer = 2
Public Const GMODE_LISTMODE1                        As Integer = 3
Public Const GMODE_TIMESTAMP_LEVEL_TRIGGERED        As Integer = 3
Public Const GMODE_LISTMODE2                        As Integer = 4
Public Const GMODE_TIMESTAMP_EDGE_TRIGGERED         As Integer = 4
Public Const GMODE_TIMESTAMP_AHRC                   As Integer = 5
Public Const GMODE_LISTMODE3                        As Integer = 5
Public Const GMODE_LISTMODE4                        As Integer = 6
Public Const GMODE_LISTMODE5                        As Integer = 7

Public Const MODE_MCA                               As Integer = 0
Public Const MODE_MCS                               As Integer = 1

Public Const MCS_INPUT_TTL                          As Integer = 0
Public Const MCS_INPUT_RATE                         As Integer = 1
Public Const MCS_INPUT_DISCR                        As Integer = 2

Public Const ADC_AMPLIFIER                          As Integer = 0
Public Const ADC_P10_DIRECT                         As Integer = 1
Public Const ADC_N10_DIRECT                         As Integer = 2
Public Const ADC_P3_DIRECT                          As Integer = 3
Public Const ADC_N3_DIRECT                          As Integer = 4

Public Const ADC_SHAPING                            As Integer = 0
Public Const ADC_DIRECT_POS                         As Integer = 3
Public Const ADC_DIRECT_NEG                         As Integer = 4

Public Const INPUT_POLARITY_POS                     As Integer = 0
Public Const INPUT_POLARITY_NEG                     As Integer = 1

Public Const PRESET_NONE                            As Integer = 0
Public Const PRESET_REAL                            As Integer = 1
Public Const PRESET_LIVE                            As Integer = 2
Public Const PRESET_INT                             As Integer = 3
Public Const PRESET_AREA                            As Integer = 4
Public Const PRESET_REAL_MILLISECONDS               As Integer = 5

Public Const STAB_STARTED                           As Integer = 0
Public Const STAB_ACTIVE                            As Integer = 1
Public Const STAB_ERROR                             As Integer = 3

Public Const TRIGGER_11                             As Integer = 0
Public Const TRIGGER_101                            As Integer = 1
Public Const TRIGGER_121                            As Integer = 2
Public Const TRIGGER_10201                          As Integer = 3
Public Const TRIGGER_4x1_12x0_4x1                   As Integer = 4
Public Const TRIGGER_4x1_4x0_4x2_4x0_4x1            As Integer = 5

Public Const GATING_NONE                            As Byte = 0
Public Const GATING_DISCARD                         As Byte = 1
Public Const GATING_SORT                            As Byte = 2
Public Const GATING_SORT_BY_STATE                   As Byte = 2
Public Const GATING_SORT_BY_TIME                    As Byte = 3

Public Const STATE_POWER_ON                         As Integer = 0
Public Const STATE_READY                            As Integer = 1
Public Const STATE_RUN                              As Integer = 2
Public Const STATE_SUSPEND                          As Integer = 3
Public Const STATE_FINISH                           As Integer = 4
Public Const STATE_ERROR                            As Integer = 5
Public Const STATE_FAIL                             As Integer = 6
Public Const STATE_WAIT_FOR_TRIGGER                 As Integer = 7

Public Const I12P_ON                                As Integer = &H10&
Public Const I12N_ON                                As Integer = &H20&
Public Const I24P_ON                                As Integer = &H40&
Public Const I24N_ON                                As Integer = &H80&
Public Const IALL_ON                                As Integer = &HF0&

Public Const IB_FAIL                                As Integer = &H1
Public Const IHV_FAIL                               As Integer = &H2
Public Const UB_LOW_FAIL                            As Integer = &H4
Public Const UB_BAD_FAIL                            As Integer = &H8
Public Const I12P_FAIL                              As Integer = &H10
Public Const I12N_FAIL                              As Integer = &H20
Public Const I24P_FAIL                              As Integer = &H40
Public Const I24N_FAIL                              As Integer = &H80

Public Const HWM_FULL                               As Integer = 0
Public Const HWM_LITE                               As Integer = 1
Public Const HWM_OEM                                As Integer = 2
Public Const HWM_MICRO                              As Integer = 3
Public Const HWM_NANO                               As Integer = 4

Public Const FEATURES_EXPANDER                      As Long = &H1&
Public Const FEATURES_INTERN_TEMPERATURE            As Long = &H2&
Public Const FEATURES_EXTERN_TEMPERATURE            As Long = &H4&
Public Const FEATURES_MAC_ADDRESS                   As Long = &H8&

Public Const FEATURES_POWER_MODULE                  As Long = &H10&
Public Const FEATURES_MSD_CARD                      As Long = &H20&
Public Const FEATURES_PMODULE_TEMPERATURE           As Long = &H40&
Public Const FEATURES_ANALOG_VOLTAGES               As Long = &H80&

Public Const FEATURES_GATING_INPUT                  As Long = &H100&
Public Const FEATURES_EXTENSION_PORT                As Long = &H200&
Public Const FEATURES_LF_REJECTION                  As Long = &H400&
Public Const FEATURES_JITTER_CORRECTION             As Long = &H800&

Public Const FEATURES_ADJUSTABLE_TRIGGER_FILTER     As Long = &H1000&
Public Const FEATURES_ADJUSTABLE_BASELINE_RESTORER  As Long = &H2000&
Public Const FEATURES_ADJUSTABLE_COARSE_GAIN        As Long = &H4000&
Public Const FEATURES_USB_RS232                     As Long = &H8000&

Public Const FEATURES_USB_CHARGING_DEFAULT_OFF      As Long = &H10000
Public Const FEATURES_NO_OFFSET_DAC                 As Long = &H20000
Public Const FEATURES_SDRAM_OK                      As Long = &H40000
Public Const FEATURES_TIMESTAMP_RECORDERS           As Long = &H80000

Public Const FEATURES_BLUETOOTH                     As Long = &H100000
Public Const FEATURES_GATING_BY_TIME                As Long = &H200000
Public Const FEATURES_BOOT_PRESETS                  As Long = &H400000
Public Const FEATURES_DETECTOR_INFO                 As Long = &H800000

Public Const FEATURES_DETECTOR_INFO_VALID           As Long = &H1000000
Public Const FEATURES_RS485_BUS                     As Long = &H2000000
Public Const FEATURES_ADDITIONAL_TEMPERATURE1       As Long = &H4000000
Public Const FEATURES_ADDITIONAL_TEMPERATURE2       As Long = &H8000000

Public Const FEATURES_FILTER2                       As Long = &H10000000
Public Const FEATURES_LISTMODE4                     As Long = &H20000000
Public Const FEATURES_LISTMODE5                     As Long = &H40000000
Public Const FEATURES_SERVE_DEBUG_INFO              As Long = &H80000000

Public Const FEATURES2_MINIMUM_EVENT_DISTANCE       As Long = &H1&
Public Const FEATURES2_SLOW_RISE                    As Long = &H2&
Public Const FEATURES2_GATING_INPUT_DOWNGRADED      As Long = &H4&

Public Const EXT_PORT_PART_A                        As Byte = &H1
Public Const EXT_PORT_PART_B                        As Byte = &H2
Public Const EXT_PORT_PART_C                        As Byte = &H4
Public Const EXT_PORT_PART_D                        As Byte = &H8
Public Const EXT_PORT_PART_E                        As Byte = &H10
Public Const EXT_PORT_PART_F                        As Byte = &H20

Public Const EXT_PORT_OFF                           As Byte = 0

Public Const EXT_PORT_PART_A_RS232                  As Byte = 4
Public Const EXT_PORT_PART_A_RS232_BUFFER           As Byte = 5

Public Const EXT_PORT_PART_B_PULSER_COMMON_START    As Byte = 1
Public Const EXT_PORT_PART_B_PULSER_SEPARATE_START  As Byte = 2
Public Const EXT_PORT_PART_B_OUTPUT                 As Byte = 3
Public Const EXT_PORT_PART_B_RS232                  As Byte = 4
Public Const EXT_PORT_PART_B_LOOP_THROUGH           As Byte = 4

Public Const EXT_PORT_PART_C_COUNTER                As Byte = 1
Public Const EXT_PORT_PART_C_TRIGGER                As Byte = 2
Public Const EXT_PORT_PART_C_INPUT                  As Byte = 3
Public Const EXT_PORT_PART_C_RS232                  As Byte = 4
Public Const EXT_PORT_PART_C_RS232_BUFFER           As Byte = 5

Public Const EXT_PORT_PART_D_PULSER_COMMON_START    As Byte = 1
Public Const EXT_PORT_PART_D_PULSER_SEPARATE_START  As Byte = 2
Public Const EXT_PORT_PART_D_OUTPUT                 As Byte = 3

Public Const EXT_PORT_PART_E_COUNTER                As Byte = 1
Public Const EXT_PORT_PART_E_TRIGGER                As Byte = 2
Public Const EXT_PORT_PART_E_INPUT                  As Byte = 3

Public Const EXT_PORT_PART_F_ON                     As Byte = 1
Public Const EXT_PORT_PART_F_ON_AT_START_UP         As Byte = 2

Public Const EXT_PORT_PART_F_PULSER_COMMON_START    As Byte = 6
Public Const EXT_PORT_PART_F_PULSER_SEPARATE_START  As Byte = 7
Public Const EXT_PORT_PART_F_OUTPUT                 As Byte = 8
Public Const EXT_PORT_PART_F_COUNTER                As Byte = 9
Public Const EXT_PORT_PART_F_TRIGGER                As Byte = 10
Public Const EXT_PORT_PART_F_INPUT                  As Byte = 11

Public Const EXT_PORT_BAUDRATE_3000000              As Integer = &H2
Public Const EXT_PORT_BAUDRATE_307200               As Integer = &H14
Public Const EXT_PORT_BAUDRATE_256000               As Integer = &H18
Public Const EXT_PORT_BAUDRATE_128000               As Integer = &H31
Public Const EXT_PORT_BAUDRATE_115200               As Integer = &H36
Public Const EXT_PORT_BAUDRATE_57600                As Integer = &H6D
Public Const EXT_PORT_BAUDRATE_56000                As Integer = &H70
Public Const EXT_PORT_BAUDRATE_38400                As Integer = &HA3
Public Const EXT_PORT_BAUDRATE_19200                As Integer = &H146
Public Const EXT_PORT_BAUDRATE_14400                As Integer = &H1B2
Public Const EXT_PORT_BAUDRATE_9600                 As Integer = &H28B
Public Const EXT_PORT_BAUDRATE_4800                 As Integer = &H516
Public Const EXT_PORT_BAUDRATE_2400                 As Integer = &HA2C
Public Const EXT_PORT_BAUDRATE_1200                 As Integer = &H1458
Public Const EXT_PORT_BAUDRATE_600                  As Integer = &H28B0
Public Const EXT_PORT_BAUDRATE_300                  As Integer = &H5160
Public Const EXT_PORT_BAUDRATE_110                  As Integer = &HDDF2

Public Const EXT_PORT_FLAGS_5BIT                    As Byte = &H0
Public Const EXT_PORT_FLAGS_6BIT                    As Byte = &H1
Public Const EXT_PORT_FLAGS_7BIT                    As Byte = &H2
Public Const EXT_PORT_FLAGS_8BIT                    As Byte = &H3
Public Const EXT_PORT_FLAGS_STOP_BITS               As Byte = &H4
Public Const EXT_PORT_FLAGS_PARITY_ENABLED          As Byte = &H8
Public Const EXT_PORT_FLAGS_EVEN_PARITY             As Byte = &H10

Public Const PUR_OFF                                As Integer = 0
Public Const PUR_ON                                 As Integer = 1

Public Const JC_OFF                                 As Integer = 0
Public Const JC_ON                                  As Integer = 1

Public Const PIN5_OFF                               As Integer = 0
Public Const PIN5_ON                                As Integer = 1

Public Const POWER_MODULE_FLAG_I_IN_MON             As Byte = &H1
Public Const POWER_MODULE_FLAG_HV_MON               As Byte = &H2
Public Const POWER_MODULE_FLAG_V_IN_MON             As Byte = &H4

Public Const CRYSTAL_UNDEFINED                      As Integer = 0
Public Const CRYSTAL_HPGe                           As Integer = 1
Public Const CRYSTAL_CdZnTe                         As Integer = 2
Public Const CRYSTAL_NaI                            As Integer = 3
Public Const CRYSTAL_CsI                            As Integer = 4
Public Const CRYSTAL_LaBr3                          As Integer = 5

Public Const VFS_LOG                                As Integer = &H7FFF
Public Const VFS_ALIN                               As Integer = &H0
Public Const VFS_64                                 As Integer = &H1
Public Const VFS_128                                As Integer = &H2
Public Const VFS_256                                As Integer = &H4
Public Const VFS_512                                As Integer = &H8
Public Const VFS_1k                                 As Integer = &H10
Public Const VFS_2k                                 As Integer = &H20
Public Const VFS_4k                                 As Integer = &H40
Public Const VFS_8k                                 As Integer = &H80
Public Const VFS_16k                                As Integer = &H100
Public Const VFS_32k                                As Integer = &H200
Public Const VFS_64k                                As Integer = &H400
Public Const VFS_128k                               As Integer = &H800
Public Const VFS_256k                               As Integer = &H1000
Public Const VFS_512k                               As Integer = &H2000
Public Const VFS_1M                                 As Integer = &H4000

Public Const SHOW_LOGO_GBS                          As Integer = -1
Public Const SHOW_LOGO_NO                           As Integer = 0

Public Const USER_INTERFACE_VERBOSE                 As Integer = -1
Public Const USER_INTERFACE_RETICENT                As Integer = 0
Public Const USER_INTERFACE_MUTE                    As Integer = 1

Public Const MCA_COMM_INIT_SIZE                     As Integer = 352

Type MCA_COMM_INIT
    unSize                                          As Integer
    unNumberToFind                                  As Integer
    bMca166                                         As Boolean
    unMca166FirmwareVersion                         As Integer
    bMca527                                         As Boolean
    unMca527FirmwareVersion                         As Integer
    nShowLogo                                       As Integer
    nUserInterface                                  As Integer
    unInterfaceId                                   As Integer
    ' 2 byte alignment
    ulBaudrate                                      As Long
    strCaption                                      As String * 60
    bRedetect                                       As Boolean
    ' 2 byte alignment
    strHelpFile                                     As String * 260
    lHelpId                                         As Long
End Type

Public Const MCA_COMM_PARAM_SIZE                    As Integer = 10

Type MCA_COMM_PARAM
    unSize                                          As Integer
    unInterfaceId                                   As Integer
    ulBaudrate                                      As Long
    nComPortNumber                                  As Integer
End Type

Type RECDATA
    lData(0 To 31)                                  As Long
    nData(0 To 1)                                   As Integer
End Type

Type SET_MEASURE_PZC
    achUnused1(0 To 105)                            As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 9)                              As Byte
    nPzcOffset527                                   As Integer
    nCheckSum                                       As Integer
    nCounts                                         As Integer
    nPzcOffset                                      As Integer
End Type

Type QUERY_POWER
    lBatteryCurrent                                 As Long
    lHvPrimaryCurrent                               As Long
    lP12PrimaryCurrent                              As Long
    lM12PrimaryCurrent                              As Long
    lP24PrimaryCurrent                              As Long
    lM24PrimaryCurrent                              As Long
    lBatteryVoltage                                 As Long
    lHighVoltage                                    As Long
    lHvState                                        As Long
    chP12Voltage                                    As Byte
    chM12Voltage                                    As Byte
    chP24Voltage                                    As Byte
    chM24Voltage                                    As Byte
    lBiasCurrentValue                               As Long
    nPin3Voltage                                    As Integer
    nPin5Voltage                                    As Integer
    lPowerSwitches                                  As Long
    lChargerCurrent                                 As Long
    nPin5CurrentSourceValue                         As Integer
    nPin5CurrentSourceState                         As Integer
    nPin5InputResistance                            As Integer
    chPin5Offset                                    As Byte
    chPin5Gain                                      As Byte
    lBatteryCurrentAtStop                           As Long
    lHvPrimaryCurrentAtStop                         As Long
    lP12PrimaryCurrentAtStop                        As Long
    lM12PrimaryCurrentAtStop                        As Long
    lP24PrimaryCurrentAtStop                        As Long
    lM24PrimaryCurrentAtStop                        As Long
    lBatteryVoltageAtStop                           As Long
    lHighVoltageAtStop                              As Long
    chPin3Offset                                    As Byte
    chPin3Gain                                      As Byte
    nPowerModuleMaxHvCtrl                           As Integer
    chP12VoltageAtStop                              As Byte
    chM12VoltageAtStop                              As Byte
    chP24VoltageAtStop                              As Byte
    chM24VoltageAtStop                              As Byte
    nPin3VoltageAtStop                              As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nPin5VoltageAtStop                              As Integer
    lChargerCurrentAtStop                           As Long
    auchUnused1(0 To 3)                             As Byte
    chPowerModuleDetectorInfoSourceAndDacType       As Byte
    chPowerModuleFlags                              As Byte
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    auchUnused2(0 To 1)                             As Byte
End Type

Type QUERY_SYSTEM_DATA
    nAlignWord0                                     As Integer
    nPdLow                                          As Integer
    lPdHigh                                         As Long
    nAlignWord1                                     As Integer
    nImpLow                                         As Integer
    lImpHigh                                        As Long
    nAlignWord2                                     As Integer
    nPdPreLow                                       As Integer
    lPdPreHigh                                      As Long
    nAlignWord3                                     As Integer
    nImpPreLow                                      As Integer
    lImpPreHigh                                     As Long
    lBtPre                                          As Long
    lTime                                           As Long
    lRealTimePrevSweep                              As Long
    lDeadTimePrevSweep                              As Long
    lStartTimePrevSweep                             As Long
    lFastDeadTimePrevSweep                          As Long
    lElSweeps                                       As Long
    lBusyTimePrevSweep                              As Long
    nRealTimeFractionalDigitsPrevSweep              As Integer
    nPdLowPrevSweep                                 As Integer
    lPdHighPrevSweep                                As Long
    nAlignWord4                                     As Integer
    nImpLowPrevSweep                                As Integer
    lImpHighPrevSweep                               As Long
    lStabCounter                                    As Long
    lAmpliDacOffset                                 As Long
    lAmpliDacOffsetMin                              As Long
    lAmpliDacOffsetMax                              As Long
    lRecCounter                                     As Long
    lRecErrorCounter                                As Long
    nRecRate                                        As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nBufferState                                    As Integer
    lStabArea                                       As Long
    nStabTime                                       As Integer
    chLowShapingTime                                As Byte
    chHighShapingTime                               As Byte
    chMinCoreClock                                  As Byte
    chMaxCoreClock                                  As Byte
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    unADCSampleRate                                 As Integer
End Type

Type QUERY_STATE
    nMcaMode                                        As Integer
    nPresets                                        As Integer
    lPresetValue                                    As Long
    lElPreset                                       As Long
    nRepeat                                         As Integer
    nElSweeps                                       As Integer
    nTimePerChannel                                 As Integer
    nElTimePerChan                                  As Integer
    lRealTime                                       As Long
    lCountsPerSec                                   As Long
    lDeadTime                                       As Long
    lBusyTime                                       As Long
    nChannels                                       As Integer
    nThreshold                                      As Integer
    nLld                                            As Integer
    nUld                                            As Integer
    nRoiBegin                                       As Integer
    nRoiEnd                                         As Integer
    nCoarseGain                                     As Integer
    nFineGain                                       As Integer
    nSlowDiscr                                      As Integer
    nFastDiscr                                      As Integer
    nDetectorBias                                   As Integer
    nDetectorBiasPoly                               As Integer
    nPreampPower                                    As Integer
    nPzcValue                                       As Integer
    nPzcDtc1Offset                                  As Integer
    nPzcDtc3Offset                                  As Integer
    nStabState                                      As Integer
    nStabResult                                     As Integer
    nStabRoiBegin                                   As Integer
    nStabRoiEnd                                     As Integer
    nMcaInputAdc                                    As Integer
    nMcaInputPol                                    As Integer
    nDtc                                            As Integer
    nMcaPur                                         As Integer
    nMcaInputMcs                                    As Integer
    nMcaNumber                                      As Integer
    nHardwareVersion                                As Integer
    nFirmwareVersion                                As Integer
    nMcsChannels                                    As Integer
    nLastPowerState                                 As Integer
    nBatteryCapacity                                As Integer
    nBatteryLifeTime                                As Integer
    lStartTime                                      As Long
    nTdf                                            As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nBufferState                                    As Integer
    lCountsPerSecEx                                 As Long
    nDiffDeadTime                                   As Integer
    nHvInhibitMode                                  As Integer
    nHvInhibitState                                 As Integer
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    nStartFlag                                      As Integer
End Type

Type QUERY_STATE527
    nHwVersion                                      As Integer
    nFwVersion                                      As Integer
    nHwModification                                 As Integer
    nFwModification                                 As Integer
    lFeatures                                       As Long
    nYear                                           As Integer
    chMonth                                         As Byte
    chDay                                           As Byte
    chHour                                          As Byte
    chMinute                                        As Byte
    chSecond                                        As Byte
    chReserve                                       As Byte
    lTestingPhase                                   As Long
    nMcaTemperature                                 As Integer
    nGeneralMode                                    As Integer
    lDiscardedCycles                                As Long
    nCoreClock                                      As Integer
    chTriggerFilterLow                              As Byte
    chTriggerFilterHigh                             As Byte
    nExpander                                       As Integer
    nOffsetDac                                      As Integer
    nDetectorTemperature                            As Integer
    nPowerModuleTemperature                         As Integer
    nMcaNumber                                      As Integer
    bAmIRightHolder                                 As Boolean
    achRightHoldersIp(0 To 3)                       As Byte
    nRightHolderPort                                As Integer
    nValidityOfRight                                As Integer
    nMaxChannels                                    As Integer
    achPowerModuleVer(0 To 1)                       As Byte
    nPowerModuleNumber                              As Integer
    nPowerModuleId                                  As Integer
    nPowerModuleMaxHv                               As Integer
    nThresholdTenths                                As Integer
    lFastDeadTime                                   As Long
    nFilterType                                     As Integer
    nFlatTopTime                                    As Integer
    nFilterSize                                     As Integer
    nTriggerLevel                                   As Integer
    nMcaTemperatureAtStop                           As Integer
    nDetectorTemperatureAtStop                      As Integer
    achIpAddressSet(0 To 3)                         As Byte
    achIpAddressActual(0 To 3)                      As Byte
    lTimePerChannel                                 As Long
    lElTimePerChannel                               As Long
    lThreshold                                      As Long
    nPowerModuleTemperatureAtStop                   As Integer
    anCmdAndParam(0 To 3)                           As Integer
    chJitterCorrection                              As Byte
    chBaselineRestoring                             As Byte
    lSetTriggerThreshold                            As Long
    chInput                                         As Byte
    chMaxShapingTime                                As Byte
    chGatingMode                                    As Byte
    chGatingSignal                                  As Byte
    chGatingShift                                   As Byte
    chHardwareCoarseGainLevels                      As Byte
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    nDiffFastDeadTime                               As Integer
End Type

Type QUERY_STATE527_EX
    lCommonMemorySize                               As Long
    lCommonMemoryFillStop                           As Long
    lCommonMemoryFillLevel                          As Long
    nOsciTimeResolution                             As Integer
    nOsciTriggerMode                                As Integer
    nOsciTriggerPosition                            As Integer
    nOsciTriggerThreshold                           As Integer
    lPurCounter                                     As Long
    chExtensionPortPartA                            As Byte
    chExtensionPortPartB                            As Byte
    chExtensionPortPartC                            As Byte
    chExtensionPortPartD                            As Byte
    chExtensionPortPartE                            As Byte
    chExtensionPortPartF                            As Byte
    chExtensionPortParts                            As Byte
    chExtensionPortStates                           As Byte
    chExtensionPortPolarities                       As Byte
    chMaxFlattopTime                                As Byte
    nBootPresetsSize                                As Integer
    lExtensionPortPulser1Period                     As Long
    lExtensionPortPulser2Period                     As Long
    lExtensionPortPulser1Width                      As Long
    lExtensionPortPulser2Width                      As Long
    nExtensionPortRs232Baudrate                     As Integer
    nExtensionPortRs232Flags                        As Integer
    lExtensionPortCounter1                          As Long
    lExtensionPortCounter1Cps                       As Long
    lExtensionPortCounter1PrevSweep                 As Long
    lExtensionPortCounter2                          As Long
    lExtensionPortCounter2Cps                       As Long
    lExtensionPortCounter2PrevSweep                 As Long
    nExtensionPortRs232TxByteCount                  As Integer
    nRealTimeFractionalDigits                       As Integer
    lPurCounterPrevSweep                            As Long
    lTriggerFilterAvailability                      As Long
    anTriggerFilterValues(0 To 1)                   As Integer
    chTtlLowLevel                                   As Byte
    chTtlHighLevel                                  As Byte
    nTriggerLevelDirectInput                        As Integer
    lAdcOverflowsPerSecond                          As Long
    nAdcSamplingRate                                As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nNeededFileSize                                 As Integer
    lSdCardTotalMemorySize                          As Long
    lSdCardFreeMemorySize                           As Long
    chFileWritingState                              As Byte
    chFileWritingResult                             As Byte
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    nRS485BusBaudrate                               As Integer
End Type

Type QUERY_STATE527_EX2
    alAhrcGroupWidth(0 To 9)                        As Long
    nAhrcTriggerThreshold                           As Integer
    nSortByTimeMcsTimePerChannel                    As Integer
    alTimeWindowsWidth(0 To 7)                      As Long
    lExtensionPortPulser3Period                     As Long
    lExtensionPortPulser3Width                      As Long
    lExtensionPortCounter3                          As Long
    lExtensionPortCounter3Cps                       As Long
    lExtensionPortCounter3PrevSweep                 As Long
    nAdditionalTemperature1                         As Integer
    nAdditionalTemperature1PrevSweep                As Integer
    nAdditionalTemperature2                         As Integer
    nAdditionalTemperature2PrevSweep                As Integer
    nFlatTopTime2                                   As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nFilterSize2                                    As Integer
    lInternalFineGain                               As Long
    lFeatures2                                      As Long
    nMinimumEventDistance                           As Integer
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    achUnused2(0 To 1)                              As Byte
End Type

Type QUERY_SPECTRA
    lChannelContents(0 To 31)                       As Long
    nBufferState                                    As Integer
    nCheckSum                                       As Integer
End Type

Type QUERY_SPECTRA_EX_LONG
    lChannelContents(0 To 31)                       As Long
    nBufferState                                    As Integer
    nCheckSum                                       As Integer
End Type

Type QUERY_SPECTRA_EX_SHORT
    nChannelContents(0 To 63)                       As Integer
    nBufferState                                    As Integer
    nCheckSum                                       As Integer
End Type

Type QUERY_SPECTRA_EX2_LONG
    lChannelContents(0 To 255)                      As Long
    nBufferState                                    As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nCheckSum                                       As Integer
End Type

Type QUERY_SPECTRA_EX2_SHORT
    nChannelContents(0 To 511)                      As Integer
    nBufferState                                    As Integer
    anCmdAndParam(0 To 3)                           As Integer
    nCheckSum                                       As Integer
End Type

Type QUERY_IMAGE
    ChannelImage(0 To 127)                          As Byte
    auchUnused(0 To 1)                              As Byte
    nCheckSum                                       As Integer
End Type

Type QUERY_ENRICHMENT
    lDeadTime                                       As Long
    lRealTime                                       As Long
    lIntegral1                                      As Long
    lIntegral2                                      As Long
    auchUnused1(0 To 89)                            As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    achUnused3(0 To 3)                              As Byte
End Type

Type QUERY_USER_DATA
    lUserData(0 To 15)                              As Long
    auchUnused1(0 To 41)                            As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    achUnused3(0 To 3)                              As Byte
End Type

Type QUERY_CENTROID
    fRoiCentroid                                    As Single
    auchUnused1(0 To 101)                           As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    achUnused3(0 To 3)                              As Byte
End Type

Type QUERY_UF6_ROIS
    lRoi1Begin                                      As Long
    lRoi1End                                        As Long
    lRoi2Begin                                      As Long
    lRoi2End                                        As Long
    lRoi3Begin                                      As Long
    lRoi3End                                        As Long
    auchUnused1(0 To 81)                            As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    achUnused3(0 To 3)                              As Byte
End Type

Type QUERY_UF6_INFO
    lDeadTime                                       As Long
    lRealTime                                       As Long
    lRoi1Integral                                   As Long
    lRoi2Integral                                   As Long
    lRoi3Integral                                   As Long
    lRoi1Begin                                      As Long
    lRoi1End                                        As Long
    lRoi2Begin                                      As Long
    lRoi2End                                        As Long
    lRoi3Begin                                      As Long
    lRoi3End                                        As Long
    lRealTimeFractionalDigits                       As Long
    lRoi1Area                                       As Long
    lRoi1AreaError                                  As Long
    lRoi2Area                                       As Long
    lRoi2AreaError                                  As Long
    lRoi3Area                                       As Long
    lRoi3AreaError                                  As Long
    auchUnused1(0 To 33)                            As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    achUnused3(0 To 3)                              As Byte
End Type

Type QUERY_VOLTAGE_CURRENT
    lChargerCurrent                                 As Long
    lHvPrimaryCurrent                               As Long
    lBatteryCurrent                                 As Long
    lBatteryVoltage                                 As Long
    lHvRef                                          As Long
    lHvCtrl                                         As Long
    lP12PrimaryCurrent                              As Long
    lP24PrimaryCurrent                              As Long
    lM24PrimaryCurrent                              As Long
    lM12PrimaryCurrent                              As Long
    auchUnused1(0 To 65)                            As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    achUnused3(0 To 3)                              As Byte
End Type

Type IP4_ADDRESS
    uchBlock1                                       As Byte
    uchBlock2                                       As Byte
    uchBlock3                                       As Byte
    uchBlock4                                       As Byte
End Type

Type QUERY_EXTENSION_RS232_RX
    unCount                                         As Integer
    chData(0 To 1023)                               As Byte
End Type

Type QUERY_ADJUSTMENT_TABLE
    nAdcAtOffsetDac1024CGain2                       As Integer
    nAdcAtOffsetDac15360CGain2                      As Integer

    nAdcAtOffsetDac1024CGain5                       As Integer
    nAdcAtOffsetDac15360CGain5                      As Integer
    
    nAdcAtOffsetDac1024CGain10                      As Integer
    nAdcAtOffsetDac15360CGain10                     As Integer
    
    nAdcAtOffsetDac1024CGain20                      As Integer
    nAdcAtOffsetDac15360CGain20                     As Integer
    
    nAdcAtOffsetDac1024CGain50                      As Integer
    nAdcAtOffsetDac15360CGain50                     As Integer
    
    nAdcAtOffsetDac1024CGain100                     As Integer
    nAdcAtOffsetDac15360CGain100                    As Integer
    
    achUnused1(0 To 81)                             As Byte
    anCmdAndParam(0 To 3)                           As Integer
    achUnused2(0 To 11)                             As Byte
    nCheckSum                                       As Integer
    nMcaState                                       As Integer
    achUnused3(0 To 1)                              As Byte
End Type

Type EFFICIENCY
    unEnergy                                        As Integer
    fEfficiency                                     As Single
End Type

Type QUERY_DETECTOR_INFO
    unSize                                          As Integer
    unCRC16                                         As Integer
    szDetectorType(0 To 31)                         As Byte
    unSerialNumber                                  As Integer
    unHvPolarity                                    As Integer
    unHvMax                                         As Integer
    unHvRecommended                                 As Integer
    uchInputType                                    As Byte
    uchInputPolarity                                As Byte
    unCoarseGain                                    As Integer
    unFineGain                                      As Integer
    unShapingTime                                   As Integer
    unFlattopTime                                   As Integer
    unTriggerFilter                                 As Integer
    unPzcValue                                      As Integer
    unDetectorMaterialCode                          As Integer
    ulArea                                          As Long
    unHeight                                        As Integer
    aunPeakshift(0 To 7)                            As Integer
    astructEfficiency(0 To 9)                       As EFFICIENCY
    achUnused(0 To 859)                             As Byte
End Type

Type PREVIOUS_SWEEP_DATA
    unAlignWord0                                    As Integer
    unDetectedCountsLow                             As Integer
    ulDetectedCountsHigh                            As Long
    unAlignWord1                                    As Integer
    unOutOfSpectrumLow                              As Integer
    ulOutOfSpectrumHigh                             As Long
    ulStartTime                                     As Long
    ulRealTime                                      As Long
    unRealTimeFractionalDigits                      As Integer
    auchUnused1(0 To 1)                             As Byte
    ulDeadTime                                      As Long
    ulFastDeadTime                                  As Long
    ulPurCounter                                    As Long
    ulBatteryCurrent                                As Long
    ulHvPrimaryCurrent                              As Long
    ulP12PrimaryCurrent                             As Long
    ulM12PrimaryCurrent                             As Long
    ulP24PrimaryCurrent                             As Long
    ulM24PrimaryCurrent                             As Long
    ulBatteryVoltage                                As Long
    ulHighVoltage                                   As Long
    uchP12Voltage                                   As Byte
    uchM12Voltage                                   As Byte
    uchP24Voltage                                   As Byte
    uchM24Voltage                                   As Byte
    unPin3Voltage                                   As Integer
    unPin5Voltage                                   As Integer
    ulChargerCurrent                                As Long
    ulExtensionPortCounter1                         As Long
    ulExtensionPortCounter2                         As Long
    ulExtensionPortCounter3                         As Long
    nMcaTemperature                                 As Integer
    nDetectorTemperature                            As Integer
    nPowerModuleTemperature                         As Integer
    nAdditionalTemperature1                         As Integer
    nAdditionalTemperature2                         As Integer
    aunCommandAndParameter(0 To 3)                  As Integer
    unBufferState                                   As Integer
    auchUnused2(0 To 9)                             As Byte
    unCheckSum                                      As Integer
    unMcaState                                      As Integer
    auchUnused3(0 To 1)                             As Byte
End Type

Declare Function IS_CURRENT_USB_PORT Lib "Mca32cmx.dll" (ByVal nIndex%) As Boolean
Declare Function GET_USB_CHARGER Lib "Mca32cmx.dll" (ByVal nIndex%) As Boolean
Declare Function GET_USB_CHARGER_STATE Lib "Mca32cmx.dll" (ByVal nIndex%) As Boolean
Declare Sub SET_USB_CHARGER Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal bCharge As Boolean)

Declare Function SET_CURRENT_LATENCY_TIMER Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal lTime As Long) As Boolean
Declare Function GET_CURRENT_LATENCY_TIMER Lib "Mca32cmx.dll" (ByVal nIndex%, ByRef lTime As Long) As Boolean

Declare Function COMM_INIT_SELECT Lib "Mca32cmx.dll" (ByRef nIndex%, req As MCA_COMM_INIT, ByVal Timeout&, ByVal lTryAgain&, ByVal hWnd&) As Integer

Declare Sub GET_COMM_PARAM Lib "Mca32cmx.dll" (ByVal nIndex%, Param As MCA_COMM_PARAM)

Declare Sub SET_TIMEOUT Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Timeout&)

Declare Sub COMM_CLOSE Lib "Mca32cmx.dll" (ByVal nIndex%)
Declare Sub COMM_TERMINATE_ETHERNET Lib "Mca32cmx.dll" ()

Declare Function MCA_COMM Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Command$, received As RECDATA, ByVal Param1&, ByVal Param2&, ByVal Param3&, ByVal Param4&) As Integer
Declare Function MCA_COMM6 Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Command$, received As RECDATA, ByVal Param1&, ByVal Param2&, ByVal Param3&, ByVal Param4&, ByVal Param5&, ByVal Param6&) As Integer

Declare Function MCA_COMM_VB Lib "Mca32cmx.dll" Alias "MCA_COMM" (ByVal nIndex%, Command As Any, received As RECDATA, ByVal Param1&, ByVal Param2&, ByVal Param3&, ByVal Param4&) As Integer

Declare Function MMCA_RESET Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_START_ACQUIRE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal ClearFlag%, ByVal StartTime&) As Integer
Declare Function MMCA_START_NEW_SWEEP Lib "Mca32cmx.dll" (ByVal nIndex%, received As PREVIOUS_SWEEP_DATA) As Integer
Declare Function MMCA_STOP_ACQUIRE Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_CLEAR_MEMORY Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_CLEAR_TIME Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_CLEAR_ROI Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_CLEAR_ALL Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SAVE_MCA_STATE Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_DELETE_MCA_STATE Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MODE_MCA Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MODE_MCS Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MODE_MCS_TTL Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MODE_MCS_DISCR Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MODE_MCS_ICR Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCS_INPUT_TTL Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCS_INPUT_DISCR Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCS_INPUT_ICR Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_ADC_RES_DISCR Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal CountOfChannel%, ByVal LLD%, ByVal ULD%) As Integer
Declare Function MMCA_SET_THRESHOLD Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Threshold%) As Integer
Declare Function MMCA_SET_PRESET_NONE Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_PRESET_LIVE_TIME Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal LiveTime&) As Integer
Declare Function MMCA_SET_PRESET_REAL_TIME Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal RealTime&) As Integer
Declare Function MMCA_SET_PRESET_INTEGRAL Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Intergral&) As Integer
Declare Function MMCA_SET_PRESET_AREA Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Area&) As Integer
Declare Function MMCA_SET_PRESET_REAL_TIME_MILLISECONDS Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal RealTime&) As Integer
Declare Function MMCA_SET_ROI Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal RoiBegin%, ByVal RoiEnd%) As Integer
Declare Function MMCA_SET_REPEAT Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Repeat%) As Integer
Declare Function MMCA_SET_TIME_PER_CHANNEL Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal time%) As Integer
Declare Function MMCA_SET_GAIN Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal CoarseGain%, ByVal FineGain%) As Integer
Declare Function MMCA_SET_STABILISATION Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal StateOrChannel%, ByVal RoiBegin%, ByVal RoiEnd%) As Integer
Declare Function MMCA_SET_PREAMPLIFIER_POWER Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal PreamplifierPower%) As Integer
Declare Function MMCA_SET_HIGH_VOLTAGES Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal HighVoltage%, ByVal Inhibit&) As Integer
Declare Function MMCA_SET_FAST Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Fast%) As Integer
Declare Function MMCA_SET_SLOW Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Slow%) As Integer
Declare Function MMCA_SET_SHAPING_TIME_LOW Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_SHAPING_TIME_HIGH Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_PILE_UP_REJECTION Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal OffOn%) As Integer
Declare Function MMCA_SET_MCA_INPUT_AMPLIFIER Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCA_INPUT_AMPLIFIER_POS Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCA_INPUT_AMPLIFIER_NEG Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCA_INPUT_DIRECT Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCA_INPUT_DIRECT_POS Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_MCA_INPUT_DIRECT_NEG Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_INPUT_POLARITY_POS Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_INPUT_POLARITY_NEG Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_USER_DATA Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Number%, ByVal UserData&) As Integer
Declare Function MMCA_SET_PZC_MANUAL Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal PZC%, received As SET_MEASURE_PZC) As Integer
Declare Function MMCA_SET_PZC_VALUE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal PZC%, received As SET_MEASURE_PZC) As Integer
Declare Function MMCA_SET_PZC_AUTOMATED Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_PZC_TIME_OFFSET Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Offset1%, ByVal Offset3%) As Integer
Declare Function MMCA_SET_TDF Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Tdf%) As Integer
Declare Function MMCA_SET_MCS_CHANNEL Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Channel%) As Integer
Declare Function MMCA_SET_UF6_ROIS Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Number%, ByVal RoiBegin%, ByVal RoiEnd%) As Integer
Declare Function MMCA_SET_STAB_PARAM Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal StabTime%, ByVal StabArea&) As Integer
Declare Function MMCA_QUERY_POWER Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_POWER) As Integer
Declare Function MMCA_QUERY_STATE Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_STATE) As Integer
Declare Function MMCA_QUERY_SPECTRA Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal FirstChannel%, ByVal CompressFactor&, received As QUERY_SPECTRA) As Integer
Declare Function MMCA_QUERY_IMAGE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal FirstChannel%, ByVal VerticalFullScale%, received As QUERY_IMAGE) As Integer
Declare Function MMCA_QUERY_ENRICHMENT Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal PeakBegin%, ByVal PeakEnd%, ByVal BackgroundBegin%, ByVal BackgroundEnd%, received As QUERY_ENRICHMENT) As Integer
Declare Function MMCA_QUERY_USER_DATA Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Number%, received As QUERY_USER_DATA) As Integer
Declare Function MMCA_QUERY_CENTROID Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal RoiBegin%, ByVal RoiEnd%, received As QUERY_CENTROID) As Integer
Declare Function MMCA_QUERY_ON_LINE Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_QUERY_SYSTEM_DATA Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_SYSTEM_DATA) As Integer
Declare Function MMCA_QUERY_UF6_ROIS Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_UF6_ROIS) As Integer
Declare Function MMCA_QUERY_UF6_INFO Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_UF6_INFO) As Integer
Declare Function MMCA_QUERY_VOLTAGE_CURRENT Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_VOLTAGE_CURRENT) As Integer

Declare Function MMCA_QUERY_SPECTRA_EX Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal FirstChannel%, ByVal CompressFactor%, ByVal BufferControl%, received As QUERY_SPECTRA) As Integer
Declare Function MMCA_QUERY_SPECTRA_EX_LONG Lib "Mca32cmx.dll" Alias "MMCA_QUERY_SPECTRA_EX" (ByVal nIndex%, ByVal FirstChannel%, ByVal CompressFactor%, ByVal BufferControl%, received As QUERY_SPECTRA_EX_LONG) As Integer
Declare Function MMCA_QUERY_SPECTRA_EX_SHORT Lib "Mca32cmx.dll" Alias "MMCA_QUERY_SPECTRA_EX" (ByVal nIndex%, ByVal FirstChannel%, ByVal CompressFactor%, ByVal BufferControl%, received As QUERY_SPECTRA_EX_SHORT) As Integer
Declare Function MMCA_QUERY_SPECTRA_EX2_LONG Lib "Mca32cmx.dll" Alias "MMCA_QUERY_SPECTRA_EX" (ByVal nIndex%, ByVal FirstChannel%, ByVal CompressFactor%, ByVal BufferControl%, received As QUERY_SPECTRA_EX2_LONG) As Integer
Declare Function MMCA_QUERY_SPECTRA_EX2_SHORT Lib "Mca32cmx.dll" Alias "MMCA_QUERY_SPECTRA_EX" (ByVal nIndex%, ByVal FirstChannel%, ByVal CompressFactor%, ByVal BufferControl%, received As QUERY_SPECTRA_EX2_SHORT) As Integer
Declare Function MMCA_QUERY_STATE527 Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_STATE527) As Integer
Declare Function MMCA_QUERY_STATE527_EX Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_STATE527_EX) As Integer
Declare Function MMCA_QUERY_STATE527_EX2 Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_STATE527_EX2) As Integer
Declare Function MMCA_SET_TRIGGER_FILTER Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal TriggerFilterLow%, ByVal TriggerFilterHigh%) As Integer
Declare Function MMCA_SET_TRIGGER_PARAM Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Param%, ByVal Value&) As Integer
Declare Function MMCA_SET_TIME Lib "Mca32cmx.dll" (ByVal nIndex%) As Integer
Declare Function MMCA_SET_GENERAL_MODE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal mode%) As Integer
Declare Function MMCA_QUERY_COMMON_MEMORY Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal ulOffset As Long, Data As Any) As Integer
Declare Function MMCA_QUERY_HISTOGRAM Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Offset%, ByVal CompressFactor%, Data As Any) As Integer
Declare Function MMCA_QUERY_ADJUSTMENT_TABLE Lib "Mca32cmx.dll" (ByVal nIndex%, received As QUERY_ADJUSTMENT_TABLE) As Integer
Declare Function MMCA_SET_OFFSET_DAC Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Value%) As Integer
Declare Function MMCA_SET_IP_ADDRESS Lib "Mca32cmx.dll" (ByVal nIndex%, Address As IP4_ADDRESS) As Integer
Declare Function MMCA_SET_SHAPING_TIME_PAIR Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal nLow%, ByVal nHigh%) As Integer
Declare Function MMCA_SET_THRESHOLD_TENTHS Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal Threshold%) As Integer
Declare Function MMCA_SET_GATING Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal mode As Byte, ByVal Polarity As Byte, ByVal Shift As Byte) As Integer
Declare Function MMCA_SET_GATING_TIME_WINDOW_WIDTH Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unWindow As Integer, ByVal ulWidth As Long) As Integer
Declare Function MMCA_SET_GATING_TIME_PER_CHANNEL Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unTimePerChannel) As Integer
Declare Function MMCA_SET_JITTER_CORRECTION Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal JitterCorrection%) As Integer
Declare Function MMCA_SET_MINIMUM_EVENT_DISTANCE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unMinimumEventDistance As Integer) As Integer
Declare Function MMCA_SET_FLAT_TOP_TIME Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal FlatTopTime%) As Integer
Declare Function MMCA_SET_FLAT_TOP_TIME2 Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal FlatTopTime%, ByVal FlatTopTime2%) As Integer
Declare Function MMCA_SET_EVAL_FILTER_TYPE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal FilterType%) As Integer
Declare Function MMCA_SET_COMMON_MEMORY_FILL_STOP Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal ulFillStop As Long) As Integer
Declare Function MMCA_SET_TIME_PER_CHANNEL527 Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal time&) As Integer
Declare Function MMCA_SET_BASELINE_RESTORING Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal uchOption As Byte) As Integer
Declare Function MMCA_SET_PIN5_CURRENT_SOURCE Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal uchOption As Byte) As Integer
Declare Function MMCA_SET_EXTENSION_PORT Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal uchA As Byte, ByVal uchB As Byte, ByVal uchC As Byte, ByVal uchD As Byte, ByVal uchE As Byte, ByVal uchF As Byte) As Integer
Declare Function MMCA_SET_EXTENSION_POLARITY Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unPart%, ByVal unPolarity%) As Integer
Declare Function MMCA_SET_EXTENSION_PULSER_PERIOD Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unPart%, ByVal ulPeriod&) As Integer
Declare Function MMCA_SET_EXTENSION_PULSER_WIDTH Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unPart%, ByVal ulWidth&) As Integer
Declare Function MMCA_SET_EXTENSION_RS232 Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal nBaudrate As Integer, ByVal chFlags As Byte) As Integer
Declare Function MMCA_SET_EXTENSION_OUTPUT Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal nRelevantParts%, ByVal nPartB%, nPartD%) As Integer
Declare Function MMCA_SET_EXTENSION_OUTPUT_EX Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal nRelevantParts%, ByVal nPartB%, nPartD%, nPartF%) As Integer
Declare Function MMCA_WRITE_TO_EXTENSION Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal strString$) As Integer
Declare Function MMCA_QUERY_EXTENSION_RS232_RX Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal nOption As Integer, received As QUERY_EXTENSION_RS232_RX) As Integer
Declare Function MMCA_READ_FROM_EXTENSION Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal strString As String, ByVal nSize As Integer) As Integer
Declare Function MMCA_READ_FROM_EXTENSION_EX Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal nOption As Integer, ByVal strString As String, ByVal nSize As Integer) As Integer
Declare Function MMCA_SET_TTL_LEVELS Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unLowLevel As Integer, ByVal unHighLevel As Integer) As Integer
Declare Function MMCA_SET_CORE_CLOCK Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unCoreClock As Integer) As Integer
Declare Function MMCA_SET_AHRC_PARAM Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unThreshold As Integer, ByRef ulGroupWidth As Any) As Integer
Declare Function MMCA_QUERY_AHRC_HISTOGRAM Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unClassWidth As Integer, Data As Any) As Integer
Declare Function MMCA_QUERY_DETECTOR_INFO Lib "Mca32cmx.dll" (ByVal nIndex%, ByVal unRange As Integer, Data As QUERY_DETECTOR_INFO) As Integer


