// TestMca32comDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestMca32com.h"
#include "TestMca32comDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestMca32comDlg dialog

CTestMca32comDlg::CTestMca32comDlg(CWnd* pParent /*=NULL*/)	: CDialog(CTestMca32comDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestMca32comDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

  m_unTimer=0;
}

BEGIN_MESSAGE_MAP(CTestMca32comDlg, CDialog)
	//{{AFX_MSG_MAP(CTestMca32comDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMca32comDlg message handlers

BOOL CTestMca32comDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  Connect(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMca32comDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMca32comDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestMca32comDlg::OnButtonConnect() 
{ Connect(TRUE);
}

void CTestMca32comDlg::Connect(BOOL bOnButtonConnect)
{ if(m_unTimer)
  { GetDlgItem(IDC_STATIC_INFO)->SetWindowText("");
  
    GetDlgItem(IDC_BUTTON_CONNECT)->SetWindowText("Connect MCA-527 ...");

    KillTimer(0);
  
    m_unTimer=0;

    COMM_CLOSE();
  }
  else
  { MCA_COMM_INIT init;

    init.nShowLogo=bOnButtonConnect ? SHOW_LOGO_NO : SHOW_LOGO_GBS;

    if(COMM_INIT_SELECT(&init,1000,4,bOnButtonConnect ? m_hWnd : NULL))
    { if(MMCA_QUERY_STATE527((char*)&m_QState527)!=ERROR_OK)
      { MessageBox("The connection to the MCA-527 has been brocken!",NULL,MB_ICONEXCLAMATION);
        COMM_CLOSE();
        return;
      }

      if(m_QState527.unMcaState==STATE_RUN || m_QState527.unMcaState==STATE_WAIT_FOR_TRIGGER)
      { if(MessageBox("The MCA-527 is running a measurement or is waiting for the trigger!\n\nDo you want to stop?",NULL,MB_ICONQUESTION | MB_YESNO)==IDYES)
        { if(MMCA_STOP_ACQUIRE()!=ERROR_OK)
          { MessageBox("The connection to the MCA-527 has been brocken!",NULL,MB_ICONEXCLAMATION);
            COMM_CLOSE();
            return;
          }
        }

        // Reset to the default settings. 

        if(MMCA_RESET()!=ERROR_OK)
        { MessageBox("The connection to the MCA-527 has been brocken!",NULL,MB_ICONEXCLAMATION);
          COMM_CLOSE();
          return;
        }
      }

      if(m_unTimer=SetTimer(0,1000,NULL))
        GetDlgItem(IDC_BUTTON_CONNECT)->SetWindowText("Disconnect MCA-527");
      else
        COMM_CLOSE();
    }
  }  
}

void CTestMca32comDlg::OnTimer(UINT nIDEvent) 
{
	if(MMCA_QUERY_STATE((char*)&m_QState)==ERROR_OK && MMCA_QUERY_STATE527((char*)&m_QState527)==ERROR_OK)
  { char szBuffer[100];

    if(m_QState527.nMcaTemperature==0x8000)
      sprintf(szBuffer,"Battery = %u %%,   Temperature = n.a.",m_QState.unBatteryCapacity);
    else
      sprintf(szBuffer,"Battery = %u %%,   Temperature = %3.2f C",m_QState.unBatteryCapacity,(double)m_QState527.nMcaTemperature/128.0);
  
    GetDlgItem(IDC_STATIC_INFO)->SetWindowText(szBuffer);
  }
  else
  { GetDlgItem(IDC_STATIC_INFO)->SetWindowText("");
  
    MessageBox("The connection to the MCA-527 has been brocken!",NULL,MB_ICONEXCLAMATION);
    KillTimer(0);
  
    m_unTimer=0;
    COMM_CLOSE();
  }
	
	CDialog::OnTimer(nIDEvent);
}

void CTestMca32comDlg::OnClose() 
{ if(m_unTimer)
  { KillTimer(0);
  
    m_unTimer=0;

    COMM_CLOSE();
  }

  CDialog::OnClose();
}
