#ifndef _MCA_COMM_H_
#define _MCA_COMM_H_

typedef short VB_BOOL;

#define VB_TRUE                                 ((short)-1)
#define VB_FALSE                                ((short)0)

#define SHOW_LOGO_GBS                           -1
#define SHOW_LOGO_NO                            0

#define USER_INTERFACE_VERBOSE                  -1
#define USER_INTERFACE_RETICENT                 0    
#define USER_INTERFACE_MUTE                     1

#define ERROR_FLAG                              short
#define UNUSED_BYTE                             unsigned char

#define COMM_INTERFACE_ETHERNET                 ((short)0)
#define COMM_INTERFACE_COM1                     ((short)1)
#define COMM_INTERFACE_COM256                   ((short)256)
#define COMM_INTERFACE_USB                      ((short)257)
#define COMM_INTERFACE_USB_CHARGER              ((short)258)
#define COMM_INTERFACE_COM1_RS485               ((short)259)
#define COMM_INTERFACE_COM256_RS485             ((short)514)
#define COMM_INTERFACE_USB_RS485                ((short)515)

#define ERROR_OK                                0
#define ERROR_INTERFACE                         1
#define ERROR_UNKNOWN_COMMAND                   2
#define ERROR_COMMUNICATION                     3
#define ERROR_INVALID_PARAM                     4
#define ERROR_RUNNING_MEAS                      5
#define ERROR_VIOLATED_RIGHT                    6
#define ERROR_STOPPED_MEAS                      7
#define ERROR_WRONG_MODE                        8
#define ERROR_UNHANDLED_COMMAND                 9
#define ERROR_FILE_WRITING_IN_PROCCESS          10

#define GMODE_MCA                               0
#define GMODE_TRANSFER_ADC_VALUES               1
#define GMODE_OSCILLOSCOPE                      2
#define GMODE_LISTMODE1                         3
#define GMODE_TIMESTAMP_LEVEL_TRIGGERED         3
#define GMODE_LISTMODE2                         4
#define GMODE_TIMESTAMP_EDGE_TRIGGERED          4
#define GMODE_LISTMODE3                         5
#define GMODE_TIMESTAMP_AHRC                    5
#define GMODE_LISTMODE4                         6
#define GMODE_LISTMODE5                         7

#define MODE_MCA                                0
#define MODE_MCS                                1

#define MCS_INPUT_TTL                           0
#define MCS_INPUT_RATE                          1
#define MCS_INPUT_DISCR                         2

#define ADC_AMPLIFIER                           0
#define ADC_P10_DIRECT                          1
#define ADC_N10_DIRECT                          2
#define ADC_P3_DIRECT                           3
#define ADC_N3_DIRECT                           4

#define ADC_SHAPING                             0
#define ADC_DIRECT_POS                          3
#define ADC_DIRECT_NEG                          4

#define INPUT_POLARITY_POSITIVE                 0
#define INPUT_POLARITY_NEGATIVE                 1

#define PRESET_NONE                             0
#define PRESET_REAL                             1
#define PRESET_LIVE                             2
#define PRESET_INT                              3
#define PRESET_AREA                             4
#define PRESET_REAL_MILLISECONDS               	5

#define STAB_STARTED                            0
#define STAB_ACTIVE                             1
#define STAB_ERROR                              3

#define TRIGGER_11                              0
#define TRIGGER_101                             1
#define TRIGGER_121                             2
#define TRIGGER_10201                           3
#define TRIGGER_4x1_12x0_4x1                    4
#define TRIGGER_4x1_4x0_4x2_4x0_4x1             5

#define GATING_NONE                             0
#define GATING_DISCARD                          1
#define GATING_SORT_BY_STATE                    2
#define GATING_SORT_BY_TIME                     3

#define STATE_POWER_ON                          0
#define STATE_READY                             1
#define STATE_RUN                               2
#define STATE_SUSPEND                           3
#define STATE_FINISH                            4
#define STATE_STOP                              5
#define STATE_FAIL                              6
#define STATE_WAIT_FOR_TRIGGER                  7

#define I12P_ON                                 0x10
#define I12N_ON                                 0x20
#define I24P_ON                                 0x40
#define I24N_ON                                 0x80
#define IALL_ON                                 0xF0

#define IB_FAIL                                	0x01
#define IHV_FAIL                               	0x02
#define UB_LOW_FAIL                            	0x04
#define UB_BAD_FAIL                            	0x08
#define I12P_FAIL                              	0x10
#define I12N_FAIL                              	0x20
#define I24P_FAIL                              	0x40
#define I24N_FAIL                              	0x80

#define FEATURES_EXPANDER                       0x00000001
#define FEATURES_INTERN_TEMPERATURE             0x00000002
#define FEATURES_EXTERN_TEMPERATURE             0x00000004
#define FEATURES_MAC_ADDRESS                    0x00000008

#define FEATURES_POWER_MODULE                   0x00000010
#define FEATURES_MSD_CARD                       0x00000020
#define FEATURES_PMODULE_TEMPERATURE            0x00000040
#define FEATURES_ANALOG_VOLTAGES                0x00000080

#define FEATURES_GATING_INPUT                   0x00000100
#define FEATURES_EXTENSION_PORT                 0x00000200
#define FEATURES_LF_REJECTION                   0x00000400
#define FEATURES_JITTER_CORRECTION              0x00000800

#define FEATURES_ADJUSTABLE_TRIGGER_FILTER      0x00001000
#define FEATURES_ADJUSTABLE_BASELINE_RESTORER   0x00002000
#define FEATURES_ADJUSTABLE_COARSE_GAIN         0x00004000
#define FEATURES_USB_RS232                      0x00008000

#define FEATURES_USB_CHARGING_DEFAULT_OFF       0x00010000
#define FEATURES_NO_OFFSET_DAC                  0x00020000
#define FEATURES_SDRAM_OK                       0x00040000
#define FEATURES_TIMESTAMP_RECORDERS            0x00080000

#define FEATURES_BLUETOOTH                      0x00100000
#define FEATURES_GATING_BY_TIME                 0x00200000
#define FEATURES_BOOT_PRESETS                   0x00400000
#define FEATURES_DETECTOR_INFO                  0x00800000

#define FEATURES_DETECTOR_INFO_VALID            0x01000000
#define FEATURES_RS485_BUS                      0x02000000
#define FEATURES_ADDITIONAL_TEMPERATURE1        0x04000000
#define FEATURES_ADDITIONAL_TEMPERATURE2        0x08000000

#define FEATURES_FILTER2                        0x10000000
#define FEATURES_LISTMODE4                      0x20000000
#define FEATURES_LISTMODE5                      0x40000000
#define FEATURES_SERVE_DEBUG_INFO               0x80000000

#define FEATURES2_MINIMUM_EVENT_DISTANCE        0x00000001
#define FEATURES2_SLOW_RISE                     0x00000002

// Flags for the extension port of the MCA527

#define EXT_PORT_PART_A                         0x01
#define EXT_PORT_PART_B                         0x02
#define EXT_PORT_PART_C                         0x04
#define EXT_PORT_PART_D                         0x08
#define EXT_PORT_PART_E                         0x10
#define EXT_PORT_PART_F                         0x20

#define EXT_PORT_OFF                            0

#define EXT_PORT_PART_A_RS232                   4
#define EXT_PORT_PART_A_RS232_BUFFER            5

#define EXT_PORT_PART_B_PULSER_COMMON_START     1
#define EXT_PORT_PART_B_PULSER_SEPARATE_START   2
#define EXT_PORT_PART_B_OUTPUT                  3
#define EXT_PORT_PART_B_RS232                   4
#define EXT_PORT_PART_B_LOOP_THROUGH           	4

#define EXT_PORT_PART_C_COUNTER                 1
#define EXT_PORT_PART_C_TRIGGER                 2
#define EXT_PORT_PART_C_INPUT                   3
#define EXT_PORT_PART_C_RS232                   4
#define EXT_PORT_PART_C_RS232_BUFFER            5

#define EXT_PORT_PART_D_PULSER_COMMON_START     1
#define EXT_PORT_PART_D_PULSER_SEPARATE_START   2
#define EXT_PORT_PART_D_OUTPUT                  3

#define EXT_PORT_PART_E_COUNTER                 1
#define EXT_PORT_PART_E_TRIGGER                 2
#define EXT_PORT_PART_E_INPUT                   3

#define EXT_PORT_PART_F_ON                      1
#define EXT_PORT_PART_F_ON_AT_START_UP          2

#define EXT_PORT_PART_F_PULSER_COMMON_START     6
#define EXT_PORT_PART_F_PULSER_SEPARATE_START   7
#define EXT_PORT_PART_F_OUTPUT                  8
#define EXT_PORT_PART_F_COUNTER                 9
#define EXT_PORT_PART_F_TRIGGER                 10
#define EXT_PORT_PART_F_INPUT                   11

// Baud rates for the extension port of the MCA527

#define EXT_PORT_BAUDRATE_3000000               0x0002
#define EXT_PORT_BAUDRATE_307200                0x0014
#define EXT_PORT_BAUDRATE_256000                0x0018
#define EXT_PORT_BAUDRATE_128000                0x0031
#define EXT_PORT_BAUDRATE_115200                0x0036
#define EXT_PORT_BAUDRATE_57600                 0x006D
#define EXT_PORT_BAUDRATE_56000                 0x0070
#define EXT_PORT_BAUDRATE_38400                 0x00A3
#define EXT_PORT_BAUDRATE_19200                 0x0146
#define EXT_PORT_BAUDRATE_14400                 0x01B2
#define EXT_PORT_BAUDRATE_9600                  0x028B
#define EXT_PORT_BAUDRATE_4800                  0x0516
#define EXT_PORT_BAUDRATE_2400                  0x0A2C
#define EXT_PORT_BAUDRATE_1200                  0x1458
#define EXT_PORT_BAUDRATE_600                   0x28B0
#define EXT_PORT_BAUDRATE_300                   0x5160
#define EXT_PORT_BAUDRATE_110                   0xDDF2

#define EXT_PORT_FLAGS_5BIT                     0x00
#define EXT_PORT_FLAGS_6BIT                     0x01
#define EXT_PORT_FLAGS_7BIT                     0x02
#define EXT_PORT_FLAGS_8BIT                     0x03
#define EXT_PORT_FLAGS_STOP_BITS                0x04
#define EXT_PORT_FLAGS_PARITY_ENABLED           0x08
#define EXT_PORT_FLAGS_EVEN_PARITY              0x10

#define PUR_OFF                                	0
#define PUR_ON                                  1

#define JC_OFF                                  0
#define JC_ON                                   1

#define PIN5_OFF                                0
#define PIN5_ON                                 1

#define POWER_MODULE_FLAG_I_IN_MON              0x01
#define POWER_MODULE_FLAG_HV_MON                0x02
#define POWER_MODULE_FLAG_V_IN_MON              0x04

#define CRYSTAL_UNDEFINED                       0
#define CRYSTAL_HPGe                            1
#define CRYSTAL_CdZnTe                          2
#define CRYSTAL_NaI                             3
#define CRYSTAL_CsI                             4
#define CRYSTAL_LaBr3                           5

#define VFS_LOG                                0x7FFF
#define VFS_ALIN                               0x0000
#define VFS_64                                 0x0001
#define VFS_128                                0x0002
#define VFS_256                                0x0004
#define VFS_512                                0x0008
#define VFS_1k                                 0x0010
#define VFS_2k                                 0x0020
#define VFS_4k                                 0x0040
#define VFS_8k                                 0x0080
#define VFS_16k                                0x0100
#define VFS_32k                                0x0200
#define VFS_64k                                0x0400
#define VFS_128k                               0x0800
#define VFS_256k                               0x1000
#define VFS_512k                               0x2000
#define VFS_1M                                 0x4000

struct MCA_COMM_INIT
{ unsigned short  unSize;
  unsigned short  unNumberToFind;
  VB_BOOL         bMca166;
  unsigned short  unMca166FirmwareVersion;
  VB_BOOL         bMca527;
  unsigned short  unMca527FirmwareVersion;
  short           nShowLogo;
  short           nUserInterface;
  unsigned short  unInterfaceId;
  // 2 byte alignment
  unsigned long   ulBaudrate;

  char            szHelpFile[MAX_PATH];
  unsigned long   ulHelpId;

  MCA_COMM_INIT()
  { unSize=sizeof(MCA_COMM_INIT);
    unNumberToFind=0;
    bMca166=VB_FALSE;
    unMca166FirmwareVersion=0xFFFF;
    bMca527=VB_TRUE;
    unMca527FirmwareVersion=0x1116;
    nShowLogo=VB_FALSE;
    nUserInterface=USER_INTERFACE_VERBOSE;
    unInterfaceId=0xFFFF;
    ulBaudrate=0L;
    memset(szHelpFile,0,MAX_PATH);
    ulHelpId=0xFFFFFFFF;
  }
};

struct MCA_COMM_PARAM
{ unsigned short  unSize;
  unsigned short  unInterfaceId;
  unsigned long   ulBaudrate;
  unsigned short  unComPortNumber;

  MCA_COMM_PARAM()
  { unSize=sizeof(MCA_COMM_PARAM);
  }
};

#pragma pack (1)

struct RECDATA
{ unsigned long   ulData[32];
  unsigned short  unData[2];
};

struct SET_MEASURE_PZC
{ UNUSED_BYTE	auchUnused1[106];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[10];
  short           nPzcOffset527;                  
  unsigned short  unCheckSum,
                  unCounts;
  short           nPzcOffset;
};

struct QUERY_POWER
{ unsigned long   ulBatteryCurrent,
                  ulHvPrimaryCurrent,
                  ulP12PrimaryCurrent,
                  ulM12PrimaryCurrent,
                  ulP24PrimaryCurrent,
                  ulM24PrimaryCurrent,
                  ulBatteryVoltage,
                  ulHighVoltage,
                  ulHvState;

  unsigned char   uchP12Voltage,
                  uchM12Voltage,
                  uchP24Voltage,
                  uchM24Voltage;

  unsigned long   ulBiasCurrentValue;

  unsigned short  unPin3Voltage,
                  unPin5Voltage;

  unsigned long   ulPowerSwitches,
                  ulChargerCurrent;

  unsigned short  unPin5CurrentSourceValue,
                  unPin5CurrentSourceState,
                  
                  unPin5Resistor;

  char            chPin5Offset,
                  chPin5Gain;

  unsigned long   ulBatteryCurrentAtStop,
                  ulHvPrimaryCurrentAtStop,
                  ulP12PrimaryCurrentAtStop,
                  ulM12PrimaryCurrentAtStop,
                  ulP24PrimaryCurrentAtStop,
                  ulM24PrimaryCurrentAtStop,
                  ulBatteryVoltageAtStop,
                  ulHighVoltageAtStop;

  char            chPin3Offset,
                  chPin3Gain;

  unsigned short  unPowerModuleMaxHvCtrl;

  unsigned char   uchP12VoltageAtStop,
                  uchM12VoltageAtStop,
                  uchP24VoltageAtStop,
                  uchM24VoltageAtStop;

  unsigned short  unPin3VoltageAtStop,

                  aunCommandAndParameter[4],

                  unPin5VoltageAtStop;

  unsigned long   ulChargerCurrentAtStop;

  UNUSED_BYTE     auchUnused1[4];

  unsigned char   uchPowerModuleDetectorInfoSource  : 4,
                  uchPowerModuleDacType             : 4,
                  uchPowerModuleFlags;

  unsigned short  unCheckSum,

                  unMcaState;

  UNUSED_BYTE     auchUnused2[2];
};

// The following 8 members of struct QUERY_SYSTEM_DATA has been renamed.
// The new names are more suitable for the parameter.
// In order to avoid errors in already existing projects,
// the old names are translated into the new names.

#define ulRealTime1           ulRealTimePrevSweep
#define ulDeadTime1           ulDeadTimePrevSweep
#define ulStartTime1          ulStartTimePrevSweep
#define ulBusyTime1           ulBusyTimePrevSweep
#define nPdLow1               nPdLowPrevSweep
#define ulPdHigh1             ulPdHighPrevSweep
#define unImpLow1             unImpLowPrevSweep
#define ulImpHigh1            ulImpHighPrevSweep

struct QUERY_SYSTEM_DATA
{ unsigned short  unAlignWord0,
                  unPdLow;
  unsigned long   ulPdHigh;
  unsigned short  unAlignWord1,
                  unImpLow;
  unsigned long   ulImpHigh;
  unsigned short  unAlignWord2,
                  unOutOfSpectrumLow;
  unsigned long   ulOutOfSpectrumHigh;
  unsigned short  unAlignWord3,
                  unOutOfSpectrumLowPrevSweep;
  unsigned long   ulOutOfSpectrumHighPrevSweep,
                  ulBtPre,
                  ulTime,
                  ulRealTimePrevSweep,
                  ulDeadTimePrevSweep,
                  ulStartTimePrevSweep,
                  ulFastDeadTimePrevSweep,
                  ulElSweeps,
                  ulBusyTimePrevSweep;
  unsigned short  unRealTimeFractionalDigitsPrevSweep,
                  nPdLowPrevSweep;
  unsigned long   ulPdHighPrevSweep;
  unsigned short  unAlignWord4,
                  unImpLowPrevSweep;
  unsigned long   ulImpHighPrevSweep,
                  ulStabCounter;
  long            lAmpliDacOffset,
                  lAmpliDacOffsetMin,
                  lAmpliDacOffsetMax;
  unsigned long   ulRecCounter,
                  ulRecErrorCounter;
  unsigned short  unRecRate,
                  aunCommandAndParameter[4],
                  unBufferState;
  unsigned long   ulStabArea;
  unsigned short  unStabTime;
  BYTE            uchLowShapingTime,
                  uchHighShapingTime,
                  uchMinCoreClock,
                  uchMaxCoreClock;
  unsigned short  unCheckSum,
                  unMcaState,
                  unADCSampleRate;
};

struct QUERY_STATE
{ unsigned short  unMcaMode,          
                  unPresets;
  unsigned long   ulPresetValue,
                  ulElPreset;
  unsigned short  unRepeat,
                  unElSweeps,
                  unTimePerChannel,
                  unElTimePerChan;
  unsigned long   ulRealTime,
                  ulCountsPerSec,
                  ulDeadTime,
                  ulBusyTime;
  unsigned short  unChannels,
                  unThreshold,
                  unLld,
                  unUld,
                  unRoiBegin,
                  unRoiEnd,
                  unCoarseGain,
                  unFineGain,
                  unSlowDiscr,
                  unFastDiscr,
                  unDetectorBias,
                  unDetectorBiasPoly,
                  unPreampPower,
                  unPzcValue,
                  unPzcDtc1Offset,
                  unPzcDtc3Offset,
                  unStabState,
                  unStabResult,
                  unStabRoiBegin,
                  unStabRoiEnd,
                  unMcaInputAdc,
                  unMcaInputPol,
                  unDtc,
                  unMcaPur,
                  unMcaInputMcs,
                  unMcaNumber,
                  unHardwareVersion,
                  unFirmwareVersion,
                  unMcsChannels,
                  unLastPowerState,
                  unBatteryCapacity,
                  unBatteryLifeTime;
  unsigned long   ulStartTime;
  unsigned short  unTdf,
                  aunCommandAndParameter[4],
                  unBufferState;
  unsigned long   ulAmpliDacVal;
  unsigned short  unDiffDeadTime;
  short           nHvInhibitMode;
  unsigned short  unHvInhibitState,
                  unCheckSum,
                  unMcaState,
                  unStartFlag;
};

struct QUERY_STATE527
{ unsigned short  unHwVersion,
                  unFwVersion,

                  unHwModification,
                  unFwModification;

  unsigned long   ulFeatures;

  unsigned short  unYear;
  unsigned char   uchMonth,
                  uchDay,

                  uchHour,
                  uchMinute,
                  uchSecond,
                  uchReserve;

  long            lTestingPhase;

  short           nMcaTemperature;
  unsigned short  unGeneralMode;

  unsigned long   ulDiscardedCycles;

  unsigned short  unCoreClock;
  unsigned char   uchTriggerFilterLow,
                  uchTriggerFilterHigh;

  unsigned short  unExpander,
                  unOffsetDac;

  short           nDetectorTemperature;
  short           nPowerModuleTemperature;

  unsigned short  unMcaNumber,
                  unAmIRightHolder;

  unsigned char   auchRightHoldersIp[4];

  unsigned short  unRightHoldersPort;
  short           nValidityOfRight;

  unsigned short  unMaxChannels;
  unsigned char   auchPowerModuleVersions[2];

  unsigned short  unPowerModuleNumber,
                  unPowerModuleId,

                  unPowerModuleMaxHv,
                  unThresholdTenths;

  unsigned long   ulFastDeadTime;

  unsigned short  unFilterType,                                  
                  unFlatTopTime,

                  unFilterSize,
                  unTriggerLevel;

  short           nMcaTemperatureAtStop,
                  nDetectorTemperatureAtStop;

  unsigned char   auchIpAddressSet[4];

  unsigned char   auchIpAddressActual[4];
  
  unsigned long   ulTimePerChannel,
  
                  ulElTimePerChan;

  long            lTriggerThreshold;

  short           nPowerModuleTemperatureAtStop;

  unsigned short  aunCommandAndParameter[4];

  unsigned char   uchJitterCorrection,
                  uchBaselineRestoring;

  long            lSetTriggerThreshold;

  unsigned char   uchInput,
                  uchMaxShapingTime,
                  uchGatingMode,
                  uchGatingPol,

                  uchGatingShift,
                  uchHardwareCoarseGainLevels;
  unsigned short  unCheckSum,

                  unMcaState,
                  unDiffFastDeadTime;
};

struct QUERY_STATE527_EX
{ unsigned long   ulCommonMemorySize,

                  ulCommonMemoryFillStop,

                  ulCommonMemoryFillLevel;
  
  short           nOsciTimeResolution;
  unsigned short  unOsciTriggerSource,

                  unOsciTriggerPosition,
                  unOsciTriggerThreshold;

  unsigned long   ulPurCounter;

  unsigned char   uchExtensionPortPartA,
                  uchExtensionPortPartB,
                  uchExtensionPortPartC,
                  uchExtensionPortPartD,

                  uchExtensionPortPartE,
                  uchExtensionPortPartF,
                  uchExtensionPortParts,
                  uchExtensionPortStates,

                  uchExtensionPortPolarities,
                  uchMaxFlattopTime;
  unsigned short  unBootPresetsSize;

  unsigned long   ulExtensionPortPulser1Period,
                  ulExtensionPortPulser2Period,
                  ulExtensionPortPulser1Width,
                  ulExtensionPortPulser2Width;

  unsigned short  unExtensionPortRs232Baudrate,
                  unExtensionPortRs232Flags;

  unsigned long   ulExtensionPortCounter1,
                  ulExtensionPortCounter1Cps,
                  ulExtensionPortCounter1PrevSweep,
                  ulExtensionPortCounter2,
                  ulExtensionPortCounter2Cps,
                  ulExtensionPortCounter2PrevSweep;

  unsigned short  unExtensionPortRs232TxByteCount,
                  unRealTimeFractionalDigits;

  unsigned long   ulPurCounterPrevSweep;

  unsigned long   ulTriggerFilterAvailability;

  short           anTriggerFilterValues[2];

  unsigned char   uchTtlLowLevel,
                  uchTtlHighLevel;
  unsigned short  unTriggerLevelDirectInput;

  unsigned long  	ulAdcOverflowsPerSecond;
  
  unsigned short  unAdcSamplingRate,

                  aunCommandAndParameter[4],

                  unNeededFileSize;

  unsigned long   ulSdCardTotalMemorySize,
                  ulSdCardFreeMemorySize;

  char            chFileWritingState,
                  chFileWritingResult;

  unsigned short  unCheckSum,
                  unMcaState,

                  unRS485BusBaudrate;
};

struct QUERY_STATE527_EX2
{ unsigned long   aulAhrcGroupWidth[10];

  unsigned short  unAhrcTriggerThreshold,

                  unSortByTimeMcsTimePerChannel;

  unsigned long   aulTimeWindowsWidth[8];

  unsigned long   ulExtensionPortPulser3Period,
                  ulExtensionPortPulser3Width,
                  ulExtensionPortCounter3,
                  ulExtensionPortCounter3Cps,
                  ulExtensionPortCounter3PrevSweep;

  short           nAdditionalTemperature1,
                  nAdditionalTemperature1PrevSweep,
                  nAdditionalTemperature2,
                  nAdditionalTemperature2PrevSweep;

  unsigned short  unFlatTopTime2,

                  aunCommandAndParameter[4],

                  unFilter2Size;

  unsigned long   ulInternalFineGain,
  
                  ulFeatures2;
  
  unsigned short  unMinimumEventDistance,

                  unCheckSum,
                  unMcaState;

  UNUSED_BYTE     auchUnused2[2];
};

struct QUERY_SPECTRA
{ unsigned long   ulChannelContents[32];
  unsigned short  unBufferState,
                  unCheckSum;
};

struct QUERY_SPECTRA_EX_LONG
{ unsigned long   ulChannelContents[32];
  unsigned short  unBufferState,
                  unCheckSum;
};

struct QUERY_SPECTRA_EX_SHORT
{ unsigned short  unChannelContents[64];
  unsigned short  unBufferState,
                  unCheckSum;
};

struct QUERY_SPECTRA_EX2_LONG
{ unsigned long   ulChannelContents[256];
  unsigned short  unBufferState,
                  aunCommandAndParameter[4],
                  unCheckSum;
};

struct QUERY_SPECTRA_EX2_SHORT
{ unsigned short  unChannelContents[512];
  unsigned short  unBufferState,
                  aunCommandAndParameter[4],
                  unCheckSum;
};

struct QUERY_IMAGE
{ BYTE            ChannelImage[128];
  UNUSED_BYTE	auchUnused[2];
  unsigned short  unCheckSum;
};

struct QUERY_ENRICHMENT
{ unsigned long   ulDeadTime,
                  ulRealTime,
                  ulIntegral1,
                  ulIntegral2;
  UNUSED_BYTE	auchUnused1[90];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12];
  unsigned short  unCheckSum;
  UNUSED_BYTE     auchUnused3[4];
};

struct QUERY_USER_DATA
{ unsigned long   aulUserData[16];
  UNUSED_BYTE     auchUnused1[42];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12];
  unsigned short  unCheckSum;
  UNUSED_BYTE     auchUnused3[4];
};

struct QUERY_CENTROID
{ float           fRoiCentroid;
  UNUSED_BYTE     auchUnused1[102];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12];
  unsigned short  unCheckSum;
  UNUSED_BYTE     auchUnused3[4];
};

struct QUERY_UF6_ROIS
{ unsigned long   ulRoi1Begin,
                  ulRoi1End,
                  ulRoi2Begin,
                  ulRoi2End,
                  ulRoi3Begin,
                  ulRoi3End;
  UNUSED_BYTE     auchUnused1[82];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12],
                  unCheckSum;
  UNUSED_BYTE     auchUnused3[4];
};

struct QUERY_UF6_INFO
{ unsigned long   ulDeadTime,
                  ulRealTime,
                  ulRoi1Integral,
                  ulRoi2Integral,
                  ulRoi3Integral,
                  ulRoi1Begin,
                  ulRoi1End,
                  ulRoi2Begin,
                  ulRoi2End,
                  ulRoi3Begin,
                  ulRoi3End,
                  ulRealTimeFractionalDigits,
                  ulRoi1Area,
                  ulRoi1AreaError,
                  ulRoi2Area,
                  ulRoi2AreaError,
                  ulRoi3Area,
                  ulRoi3AreaError;
  UNUSED_BYTE     auchUnused1[34];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12],
                  unCheckSum;
  UNUSED_BYTE     auchUnused3[4];
};

struct QUERY_VOLTAGE_CURRENT
{ unsigned long   ulChargerCurrent,
                  ulHvPrimaryCurrent,
                  ulBatteryCurrent,
                  ulBatteryVoltage,
                  ulHvRef,
                  ulHvCtrl,
                  ulP12PrimaryCurrent,
                  ulP24PrimaryCurrent,
                  ulM24PrimaryCurrent,
                  ulM12PrimaryCurrent;
  UNUSED_BYTE     auchUnused1[66];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12],
                  unCheckSum;
  UNUSED_BYTE     auchUnused3[4];
};

struct QUERY_OSCI_SCREEN
{ unsigned long   ulPosition1,
                  ulPosition2;
  unsigned short  aunData[500];
};

struct QUERY_OSCI_SCREEN_EX
{ unsigned long   ulPosition;
  unsigned short  aunData[720];
};

struct QUERY_OSCI_TRIGGER_FILTER_RESULTS
{ long            lThreshold,
                  alData[720];
};

struct QUERY_OSCI_MAIN_FILTER_RESULTS
{ short           anData[720],
                  nJitter;
};

struct QUERY_ADJUSTMENT_TABLE
{ short           nAdcAtOffsetDac1024CGain2;
  short           nAdcAtOffsetDac15360CGain2;

  short           nAdcAtOffsetDac1024CGain5;
  short           nAdcAtOffsetDac15360CGain5;

  short           nAdcAtOffsetDac1024CGain10;
  short           nAdcAtOffsetDac15360CGain10;

  short           nAdcAtOffsetDac1024CGain20;
  short           nAdcAtOffsetDac15360CGain20;

  short           nAdcAtOffsetDac1024CGain50;
  short           nAdcAtOffsetDac15360CGain50;

  short           nAdcAtOffsetDac1024CGain100;
  short           nAdcAtOffsetDac15360CGain100;

  UNUSED_BYTE     auchUnused1[82];
  unsigned short  aunCommandAndParameter[4];
  UNUSED_BYTE     auchUnused2[12];
  unsigned short  unCheckSum,
                  unMcaState;
  UNUSED_BYTE     auchUnused3[4];
};

struct PREVIOUS_SWEEP_DATA
{ unsigned short  unAlignWord0,
                  unDetectedCountsLow;
  unsigned long   ulDetectedCountsHigh;
  unsigned short  unAlignWord1,
                  unOutOfSpectrumLow;
  unsigned long   ulOutOfSpectrumHigh,
                  ulStartTime,
                  ulRealTime;
  unsigned short  unRealTimeFractionalDigits;
  UNUSED_BYTE     auchUnused1[2];
  unsigned long   ulDeadTime,
                  ulFastDeadTime,
                  ulPurCounter,
                  ulBatteryCurrent,
                  ulHvPrimaryCurrent,
                  ulP12PrimaryCurrent,
                  ulM12PrimaryCurrent,
                  ulP24PrimaryCurrent,
                  ulM24PrimaryCurrent,
                  ulBatteryVoltage,
                  ulHighVoltage;
  unsigned char   uchP12Voltage,
                  uchM12Voltage,
                  uchP24Voltage,
                  uchM24Voltage;
  unsigned short  unPin3Voltage,
                  unPin5Voltage;
  unsigned long   ulChargerCurrent,
                  ulExtensionPortCounter1,
                  ulExtensionPortCounter2,
                  ulExtensionPortCounter3;
  short           nMcaTemperature,
                  nDetectorTemperature,
                  nPowerModuleTemperature,
                  nAdditionalTemperature1,
                  nAdditionalTemperature2;
  unsigned short  aunCommandAndParameter[4],
                  unBufferState;
  UNUSED_BYTE     auchUnused2[10];
  unsigned short  unCheckSum,
                  unMcaState;
  UNUSED_BYTE     auchUnused3[2];
};

struct DIRECTORY_ENTRY
{ char            chName[8];
  char            chExtension[3];
  unsigned char   uchAttributes;
  unsigned char   uchReserved;
  unsigned char   uchGenerationTime10ms;
  union
  { unsigned short unGenerationTime;
    struct
    { unsigned short unGenerationSecond        : 5;
      unsigned short unGenerationMinute        : 6;
      unsigned short unGenerationHour          : 5;
    };
  };
  union
  { unsigned short unGenerationDate;
    struct
    { unsigned short unGenerationDay           : 5;
      unsigned short unGenerationMonth         : 4;
      unsigned short unGenerationYear          : 7;
    };
  };
  unsigned short  unLastAccessDate;
  unsigned short  unStartClusterHighWord;
  unsigned short  unLastModificationTime;  
  unsigned short  unLastModificationDate;  
  unsigned short  unStartClusterLowWord;
  unsigned long   ulFileSize;
};

#define START_CLUSTER_MCA527_DIR        0
#define START_CLUSTER_SN_DIR            1

struct QUERY_CLUSTER
{ union
  { unsigned char   auchData[1024];
    DIRECTORY_ENTRY entries[32];
  };
  unsigned long     ulNextCluster;
  unsigned short    unNextOffset;
  unsigned short    unBytesRead;
};

#pragma pack ()


#ifdef __cplusplus
extern "C"
{ 
#endif

#ifdef _FOR_COMPATIBILITY

  short CALLBACK COMM_INIT(LPSTR lpszInterface);
  short CALLBACK COMM_INIT_EX(LPSTR lpszInterface,clock_t lTimeOut);
  short CALLBACK COMM_INIT_EX2(LPSTR lpszInterface,clock_t lTimeOut,int nTryAgain,ULONG ulBaudRate);
  short CALLBACK COMM_INIT_EX3(LPSTR lpszInterface,clock_t lTimeOut,int nTryAgain,ULONG ulBaudRate,VB_BOOL bSynchronisation);
  short CALLBACK COMM_INIT_ETHERNET(unsigned short unNumberToFind,clock_t lTimeOut,int nTryAgain,HWND hWnd);
  short CALLBACK COMM_INIT_ETHERNET_IP(LPSTR szIpAddress,clock_t lTimeOut,int nTryAgain);

#endif
  
  short CALLBACK COMM_INIT_SELECT(MCA_COMM_INIT* init,clock_t lTimeOut,int nTryAgain,HWND hWnd);

  void CALLBACK GET_COMM_PARAM(MCA_COMM_PARAM* param);

  void CALLBACK SET_TIMEOUT(clock_t lTimeOut);

  void CALLBACK COMM_CLOSE();
  void CALLBACK COMM_TERMINATE_ETHERNET();

#ifdef _FOR_COMPATIBILITY

  VB_BOOL CALLBACK IS_USB_PORT(char* lpszInterface);

#endif

  VB_BOOL CALLBACK IS_CURRENT_USB_PORT();
  VB_BOOL CALLBACK GET_USB_CHARGER();
  VB_BOOL CALLBACK GET_USB_CHARGER_STATE();
  void CALLBACK SET_USB_CHARGER(VB_BOOL bCharge);

#ifdef _FOR_COMPATIBILITY

  VB_BOOL CALLBACK SET_LATENCY_TIMER_EX(LPSTR lpszInterface,DWORD dwTime);
  VB_BOOL CALLBACK SET_LATENCY_TIMER(LPSTR lpszInterface);

#endif

  VB_BOOL CALLBACK SET_CURRENT_LATENCY_TIMER(DWORD dwTime);
  VB_BOOL CALLBACK GET_CURRENT_LATENCY_TIMER(LPDWORD dwTime);
  
  ERROR_FLAG CALLBACK MCA_COMM(LPSTR command,LPSTR rec_data,unsigned long param1=0,unsigned long param2=0,unsigned long param3=0,unsigned long param4=0);
  ERROR_FLAG CALLBACK MCA_COMM6(LPSTR command,LPSTR rec_data,unsigned long param1=0,unsigned long param2=0,unsigned long param3=0,unsigned long param4=0,unsigned long param5=0,unsigned long param6=0);

  ERROR_FLAG CALLBACK MMCA_RESET();
  ERROR_FLAG CALLBACK MMCA_START_ACQUIRE(unsigned short unClearFlag,unsigned long ulStartTime);
  ERROR_FLAG CALLBACK MMCA_START_NEW_SWEEP(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_STOP_ACQUIRE();
  ERROR_FLAG CALLBACK MMCA_CLEAR_MEMORY();
  ERROR_FLAG CALLBACK MMCA_CLEAR_TIME();
  ERROR_FLAG CALLBACK MMCA_CLEAR_ROI();
  ERROR_FLAG CALLBACK MMCA_CLEAR_ALL();
  ERROR_FLAG CALLBACK MMCA_SAVE_MCA_STATE();
  ERROR_FLAG CALLBACK MMCA_DELETE_MCA_STATE();
  ERROR_FLAG CALLBACK MMCA_SET_MODE_MCA();
  ERROR_FLAG CALLBACK MMCA_SET_MODE_MCS();
  ERROR_FLAG CALLBACK MMCA_SET_MODE_MCS_TTL();
  ERROR_FLAG CALLBACK MMCA_SET_MODE_MCS_DISCR();
  ERROR_FLAG CALLBACK MMCA_SET_MODE_MCS_ICR();
  ERROR_FLAG CALLBACK MMCA_SET_MCS_INPUT_TTL();
  ERROR_FLAG CALLBACK MMCA_SET_MCS_INPUT_DISCR();
  ERROR_FLAG CALLBACK MMCA_SET_MCS_INPUT_ICR();
  ERROR_FLAG CALLBACK MMCA_SET_ADC_RES_DISCR(unsigned short unCountOfChannels,unsigned short unLLD,unsigned short unULD);
  ERROR_FLAG CALLBACK MMCA_SET_THRESHOLD(unsigned short unThreshold);
  ERROR_FLAG CALLBACK MMCA_SET_PRESET_NONE();
  ERROR_FLAG CALLBACK MMCA_SET_PRESET_LIVE_TIME(unsigned long unLiveTime);
  ERROR_FLAG CALLBACK MMCA_SET_PRESET_REAL_TIME(unsigned long unRealTime);
  ERROR_FLAG CALLBACK MMCA_SET_PRESET_INTEGRAL(unsigned long ulIntegral);
  ERROR_FLAG CALLBACK MMCA_SET_PRESET_AREA(unsigned long ulArea);
  ERROR_FLAG CALLBACK MMCA_SET_PRESET_REAL_TIME_MILLISECONDS(unsigned long ulRealTime);
  ERROR_FLAG CALLBACK MMCA_SET_ROI(unsigned short unROIBegin,unsigned short unROIEnd);
  ERROR_FLAG CALLBACK MMCA_SET_REPEAT(unsigned short unRepeat);
  ERROR_FLAG CALLBACK MMCA_SET_TIME_PER_CHANNEL(unsigned short unTime);
  ERROR_FLAG CALLBACK MMCA_SET_GAIN(unsigned short unCoarseGain,unsigned short unFineGain);
  ERROR_FLAG CALLBACK MMCA_SET_STABILISATION(unsigned short unStateOrChannel,unsigned short unROIBegin,unsigned short unROIEnd);
  ERROR_FLAG CALLBACK MMCA_SET_PREAMPLIFIER_POWER(unsigned short nPreamplifierPower);
  ERROR_FLAG CALLBACK MMCA_SET_HIGH_VOLTAGES(unsigned short unHighVoltage, long lInhibit);
  ERROR_FLAG CALLBACK MMCA_SET_FAST(unsigned short unFast);
  ERROR_FLAG CALLBACK MMCA_SET_SLOW(unsigned short unSlow);
  ERROR_FLAG CALLBACK MMCA_SET_SHAPING_TIME_LOW();
  ERROR_FLAG CALLBACK MMCA_SET_SHAPING_TIME_HIGH();
  ERROR_FLAG CALLBACK MMCA_SET_PILE_UP_REJECTION(unsigned short unOffOn);
  ERROR_FLAG CALLBACK MMCA_SET_MCA_INPUT_AMPLIFIER();
  ERROR_FLAG CALLBACK MMCA_SET_MCA_INPUT_AMPLIFIER_POS();
  ERROR_FLAG CALLBACK MMCA_SET_MCA_INPUT_AMPLIFIER_NEG();
  ERROR_FLAG CALLBACK MMCA_SET_MCA_INPUT_DIRECT();
  ERROR_FLAG CALLBACK MMCA_SET_MCA_INPUT_DIRECT_POS();
  ERROR_FLAG CALLBACK MMCA_SET_MCA_INPUT_DIRECT_NEG();
  ERROR_FLAG CALLBACK MMCA_SET_INPUT_POLARITY_POS();
  ERROR_FLAG CALLBACK MMCA_SET_INPUT_POLARITY_NEG();
  ERROR_FLAG CALLBACK MMCA_SET_USER_DATA(unsigned short unNumber,unsigned long ulUserData);
  ERROR_FLAG CALLBACK MMCA_SET_PZC_MANUAL(unsigned short unPZC,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_SET_PZC_VALUE(unsigned short unPZC,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_SET_PZC_AUTOMATED();
  ERROR_FLAG CALLBACK MMCA_SET_PZC_TIME_OFFSET(unsigned short unOffset1,unsigned short unOffset3);
  ERROR_FLAG CALLBACK MMCA_SET_TDF(unsigned short unTdf);
  ERROR_FLAG CALLBACK MMCA_SET_MCS_CHANNEL(unsigned short unChannel);
  ERROR_FLAG CALLBACK MMCA_SET_UF6_ROIS(unsigned short unNumber,unsigned short unBegin,unsigned short unEnd);
  ERROR_FLAG CALLBACK MMCA_SET_STAB_PARAM(unsigned short unStabTime,unsigned long ulStabArea);
  ERROR_FLAG CALLBACK MMCA_QUERY_POWER(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_STATE(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_SPECTRA(unsigned short unFirstChannel,unsigned long ulCompressFactor,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_IMAGE(unsigned short unFirstChannel,unsigned short unCompressFactor,unsigned short unVerticalFullScale,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_ENRICHMENT(unsigned short unRoi1Begin,unsigned short unRoi1End,unsigned short unRoi2Begin,unsigned short unRoi2End,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_USER_DATA(unsigned short unNumber,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_CENTROID(unsigned short unRoiBegin,unsigned short ulRoiEnd,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_ON_LINE();
  ERROR_FLAG CALLBACK MMCA_QUERY_SYSTEM_DATA(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_UF6_ROIS(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_UF6_INFO(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_VOLTAGE_CURRENT(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_VOLTAGE_CURRENT_EX(LPSTR rec_data,unsigned short unHwModification);

#ifdef __WATCHMON__

  ERROR_FLAG CALLBACK MMCA_QUERY_HW_ROIS(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_WATCH_DATA(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_SPECTRUM_RF(USHORT unCount,USHORT unOffset,USHORT unCompression,USHORT unNumber,ULONG* lpulSpectrum);

#endif

  ERROR_FLAG CALLBACK MMCA_QUERY_SPECTRA_EX(unsigned short unFirstChannel,unsigned short unCompressFactor,unsigned short unBufferControl,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_SPECTRA_EX2(unsigned short unFirstChannel,unsigned short unCompressFactor,unsigned short unBufferControl,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_STATE527(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_STATE527_EX(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_STATE527_EX2(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_SET_TRIGGER_FILTER(unsigned short unTriggerFilterLow,unsigned short unTriggerFilterHigh);
  ERROR_FLAG CALLBACK MMCA_SET_TRIGGER_PARAM(unsigned short unParam,unsigned long ulValue);
  ERROR_FLAG CALLBACK MMCA_SET_TIME();
  ERROR_FLAG CALLBACK MMCA_SET_GENERAL_MODE(unsigned short unMode);
  ERROR_FLAG CALLBACK MMCA_QUERY_COMMON_MEMORY(unsigned long ulOffset,unsigned short* lpunData);
  ERROR_FLAG CALLBACK MMCA_QUERY_HISTOGRAM(unsigned short unOffset,unsigned short unCompressFactor,unsigned long* lpulData);
  ERROR_FLAG CALLBACK MMCA_QUERY_ADJUSTMENT_TABLE(LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_SET_OFFSET_DAC(unsigned short unValue);
  ERROR_FLAG CALLBACK MMCA_SET_IP_ADDRESS(unsigned char* lpuchAddress);
  ERROR_FLAG CALLBACK MMCA_SET_SHAPING_TIME_PAIR(unsigned short unLow,unsigned short unHigh);
  ERROR_FLAG CALLBACK MMCA_SET_THRESHOLD_TENTHS(unsigned short unThreshold);
  ERROR_FLAG CALLBACK MMCA_SET_GATING(unsigned char uchMode,unsigned char uchPolarity,unsigned char uchShift);
  ERROR_FLAG CALLBACK MMCA_SET_GATING_TIME_WINDOW_WIDTH(unsigned short unWindow,unsigned long ulWidth);
  ERROR_FLAG CALLBACK MMCA_SET_GATING_TIME_PER_CHANNEL(unsigned short unTimePerChannel);
  ERROR_FLAG CALLBACK MMCA_SET_JITTER_CORRECTION(unsigned short unOffOn);
  ERROR_FLAG CALLBACK MMCA_SET_MINIMUM_EVENT_DISTANCE(unsigned short unMinimumEventDistance);
  ERROR_FLAG CALLBACK MMCA_SET_FLAT_TOP_TIME(unsigned short unFlatTopTime);
  ERROR_FLAG CALLBACK MMCA_SET_FLAT_TOP_TIME2(unsigned short unFlatTopTime,unsigned short unFlatTopTime2);
  ERROR_FLAG CALLBACK MMCA_SET_EVAL_FILTER_TYPE(unsigned short unFilterType);
  ERROR_FLAG CALLBACK MMCA_SET_COMMON_MEMORY_FILL_STOP(unsigned long ulFillStop);
  ERROR_FLAG CALLBACK MMCA_SET_BASELINE_RESTORING(unsigned char uchOption);
  ERROR_FLAG CALLBACK MMCA_SET_TIME_PER_CHANNEL527(unsigned long ulTime);
  ERROR_FLAG CALLBACK MMCA_SET_PIN5_CURRENT_SOURCE(unsigned char uchOption);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_PORT(unsigned char uchA,unsigned char uchB,unsigned char uchC,unsigned char uchD,unsigned char uchE,unsigned char uchF);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_POLARITY(unsigned short unPart,unsigned short unPolarity);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_PULSER_PERIOD(unsigned short unPart,unsigned long ulPeriod);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_PULSER_WIDTH(unsigned short unPart,unsigned long ulWidth);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_RS232(unsigned short unBaudrate,unsigned char uchFlags);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_OUTPUT(unsigned short unRelevantParts,unsigned short unPartB,unsigned short unPartD);
  ERROR_FLAG CALLBACK MMCA_SET_EXTENSION_OUTPUT_EX(unsigned short unRelevantParts,unsigned short unPartB,unsigned short unPartD,unsigned short unPartF);
  ERROR_FLAG CALLBACK MMCA_WRITE_TO_EXTENSION(LPSTR lpszBuffer);
  ERROR_FLAG CALLBACK MMCA_QUERY_EXTENSION_RS232_RX(unsigned short unOption,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_READ_FROM_EXTENSION(LPSTR lpszBuffer,unsigned short unBufferSize);
  ERROR_FLAG CALLBACK MMCA_READ_FROM_EXTENSION_EX(unsigned short unOption,LPSTR lpszBuffer,unsigned short unBufferSize);
  ERROR_FLAG CALLBACK MMCA_SET_TTL_LEVELS(unsigned short unLowLevel,unsigned short unHighLevel);
  ERROR_FLAG CALLBACK MMCA_SET_CORE_CLOCK(unsigned short unClock);
  ERROR_FLAG CALLBACK MMCA_SET_AHRC_PARAM(unsigned short unThreshold,unsigned long* lpulGroupWidth);
  ERROR_FLAG CALLBACK MMCA_QUERY_AHRC_HISTOGRAM(unsigned short unClassWidth,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_DETECTOR_INFO(unsigned short unRange, LPSTR rec_data);

  ERROR_FLAG CALLBACK MMCA_QUERY_CLUSTER(unsigned long ulCluster,unsigned short unOffset,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_DELETE_FILE_STEP1(unsigned long ulStartCluster,unsigned short unGenerationTime);
  ERROR_FLAG CALLBACK MMCA_DELETE_FILE_STEP2(unsigned long ulCluster,unsigned short unOffset);
  
  ERROR_FLAG CALLBACK MMCA_SET_OSCI_TRIGGER(unsigned char uchMode,char chTimeResolution,unsigned short unTreshold,unsigned short unPosition);
  ERROR_FLAG CALLBACK MMCA_QUERY_OSCI_SCREEN(unsigned long ulPosition,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_OSCI_SCREEN_EX(unsigned short unFlags,LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_OSCI_TRIGGER_FILTER_RESULTS(unsigned short unFlag, LPSTR rec_data);
  ERROR_FLAG CALLBACK MMCA_QUERY_OSCI_MAIN_FILTER_RESULTS(LPSTR rec_data);
  
#ifdef __cplusplus
}
#endif
		
#endif
